 
nodes( nil, 0 ).
nodes( node( _, Links, Rechts), N ) :-
   nodes(Links, L),
   nodes(Rechts, R),
   N is L+R+1.

height( nil, 0 ).
height( node( _, Links, Rechts), N ) :-
   height(Links, L),
   height(Rechts, R),
   (R >= L -> N is R+1 ; N is L+1).

leafs( nil, 0 ).
leafs( node(_, nil, nil), 1 ).
leafs( node(_, Links, Rechts), N ) :-
   % wenn Links=nil und Rechts=nil waere, dann
   % handelte es sich um ein Blatt, was schon im
   % vorigen Fall behandelt wurde.
   (Links = nil -> Rechts \= nil ; true),
   leafs(Links, L),
   leafs(Rechts, R),
   N is L+R.

fibo_tree( 0, nil ).
fibo_tree( 1, node( 1, nil, nil) ).
fibo_tree( N, node( N, L, R) ):-
   N >= 2,
   N1 is N-1,
   N2 is N-2,
   fibo_tree( N1, R ),
   fibo_tree( N2, L ).


tree_insert(Y, nil, node(Y,nil,nil)).
tree_insert(Y, node(X, Links, Rechts), node(X, Links, RechtsNeu)) :-
   Y > X,
   tree_insert(Y, Rechts, RechtsNeu).
tree_insert(Y, node(X, Links, Rechts), node(X, LinksNeu, Rechts)) :-
   Y =< X,
   tree_insert(Y, Links, LinksNeu).

tree_insert_list([], Tree, Tree).
tree_insert_list([X|R], Tree, Result) :-
   tree_insert(X,Tree,NextTree),
   tree_insert_list(R,NextTree,Result).


put_rightmost(nil, R, R).
put_rightmost(node(X,L,R), Ins, node(X,L,NewR)):-
   put_rightmost(R,Ins,NewR).

tree_delete_bad(X, node(X, L, R), LUndR) :-
   put_rightmost(L,R, LUndR).
tree_delete_bad(X, node(Y, L, R), node(Y,L,NewR)):-
   Y < X,
   tree_delete_bad(X,R,NewR).
tree_delete_bad(X, node(Y, L, R), node(Y,NewL,R)):-
   Y > X,
   tree_delete_bad(X,L,NewL).


get_leftmost(node(X,nil,R), X, R).
get_leftmost(node(X,L,R), Leftmost, node(X,LRest,R)):-
   get_leftmost(L, Leftmost, LRest).

tree_delete(X, node(X, L, nil), L).
tree_delete(X, node(X, L, R), node(Leftmost,L, RRest)) :-
   get_leftmost(R, Leftmost, RRest).

tree_delete(X, node(Y, L, R), node(Y,L,NewR)):-
   Y < X,
   tree_delete(X,R,NewR).
tree_delete(X, node(Y, L, R), node(Y,NewL,R)):-
   Y > X,
   tree_delete(X,L,NewL).


tree_flatten(nil, []).
tree_flatten(node(X, Links, Rechts), Flat):-
   tree_flatten(Links, L),
   tree_flatten(Rechts, R),
   append(Links, [X|Rechts], Flat).